#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TurretSkillWing.h"
std::auto_ptr<Fish_TurretSkillWing> Fish_TurretSkillWing::msSingleton(nullptr);

int Fish_TurretSkillWing::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretSkillWingData* Fish_TurretSkillWing::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TurretSkillWingData>& Fish_TurretSkillWing::GetMapData()
{
	return mMapData;
}

void Fish_TurretSkillWing::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TurretSkillWing.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretSkillWingData data;
		data.mID = element->IntAttribute("ID");
		data.mSkillId = element->IntAttribute("SkillId");
		data.mSkillDesc = element->Attribute("SkillDesc");
		data.mValue = element->IntAttribute("Value");
		data.mValueShu = element->IntAttribute("ValueShu");
		data.mSkillResources = element->Attribute("SkillResources");
		data.mAddValue = element->IntAttribute("AddValue");
		data.mTopValue = element->IntAttribute("TopValue");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TurretSkillWing Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretSkillWing::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TurretSkillWing");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TurretSkillWing");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TurretSkillWingData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "SkillId", data.mSkillId);
		LuaCfgHelper::readString(L, "SkillDesc", data.mSkillDesc);
		LuaCfgHelper::readInt(L, "Value", data.mValue);
		LuaCfgHelper::readInt(L, "ValueShu", data.mValueShu);
		LuaCfgHelper::readString(L, "SkillResources", data.mSkillResources);
		LuaCfgHelper::readInt(L, "AddValue", data.mAddValue);
		LuaCfgHelper::readInt(L, "TopValue", data.mTopValue);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TurretSkillWing Loaded. Load Data:%u", mMapData.size());
}

void Fish_TurretSkillWing::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TurretSkillWing* Fish_TurretSkillWing::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretSkillWing());
	}
	return msSingleton.get();
}

void Fish_TurretSkillWing::Release()
{
	msSingleton.reset(nullptr);
}
